;--------------------------------------------------------
; File Created by SLCC : free open source ANSI-C Compiler
; Version 3.6.0 #Jul 10 2023 (MSVC)
;--------------------------------------------------------
; SL port for the RISC core
;--------------------------------------------------------
;	.file	"F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C"
	list	p=XC8E855E
	radix dec
	include "XC8E855E.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_file_ClrRam
	extern	_file_PWMint
	extern	_file_ADCint
	extern	_file_INTint
	extern	_file_adc_start
	extern	_IARbits
	extern	_TC0Cbits
	extern	_PCLbits
	extern	_STATUSbits
	extern	_RSRbits
	extern	_PORT6bits
	extern	_TC1CONbits
	extern	_TC1PRDbits
	extern	_PWM1DTbits
	extern	_PWM2DTbits
	extern	_PWM3DTbits
	extern	_P6IWEbits
	extern	_CPUCONbits
	extern	_INTFbits
	extern	_P6PHbits
	extern	_P6PDbits
	extern	_P6CONbits
	extern	_E2PADRbits
	extern	_E2PDATbits
	extern	_E2PCONbits
	extern	_E2PREADbits
	extern	_TC0CONbits
	extern	_SYSCONbits
	extern	_INTEbits
	extern	_IAR
	extern	_TC0C
	extern	_PCL
	extern	_STATUS
	extern	_RSR
	extern	_PORT6
	extern	_TC1CON
	extern	_TC1PRD
	extern	_PWM1DT
	extern	_PWM2DT
	extern	_PWM3DT
	extern	_P6IWE
	extern	_CPUCON
	extern	_INTF
	extern	_P6PH
	extern	_P6PD
	extern	_P6CON
	extern	_E2PADR
	extern	_E2PDAT
	extern	_E2PCON
	extern	_E2PREAD
	extern	_TC0CON
	extern	_SYSCON
	extern	_INTE
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_file_init
	global	_int_isr
	global	_file_clrRam
	global	_file_project_init
	global	_main
	global	_bit_flag1
	global	_A_BUFF
	global	_R3_BUFF
	global	_reg_contTime
	global	_reg_keyCont
	global	_reg_sleep_cnt

	global STK11
	global STK10
	global STK09
	global STK08
	global STK07
	global STK06
	global STK05
	global STK04
	global STK03
	global STK02
	global STK01
	global STK00

sharebank udata_ovr 0x0020
STK11	res 1
STK10	res 1
STK09	res 1
STK08	res 1
STK07	res 1
STK06	res 1
STK05	res 1
STK04	res 1
STK03	res 1
STK02	res 1
STK01	res 1
STK00	res 1

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
UD_XC8E855E_INT_0	udata
_bit_flag1	res	1

UD_XC8E855E_INT_1	udata
_reg_contTime	res	1

UD_XC8E855E_INT_2	udata
_reg_keyCont	res	1

UD_XC8E855E_INT_3	udata
_reg_sleep_cnt	res	1

;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
UD_abs_XC8E855E_INT_10	udata_ovr	0x0010
_A_BUFF
	res	1
UD_abs_XC8E855E_INT_11	udata_ovr	0x0011
_R3_BUFF
	res	1
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_XC8E855E_INT_0	udata
r0x1000	res	1
r0x1001	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

;@Allocation info for local variables in function 'int_isr'
;@int_isr file_init                 Allocated to registers ;size:2
;@int_isr file_ClrRam               Allocated to registers ;size:2
;@int_isr file_PWMint               Allocated to registers ;size:2
;@int_isr file_ADCint               Allocated to registers ;size:2
;@int_isr file_INTint               Allocated to registers ;size:2
;@int_isr file_adc_start            Allocated to registers ;size:2
;@int_isr int_isr                   Allocated to registers ;size:2
;@int_isr IARbits                   Allocated to registers ;size:1
;@int_isr TC0Cbits                  Allocated to registers ;size:1
;@int_isr PCLbits                   Allocated to registers ;size:1
;@int_isr STATUSbits                Allocated to registers ;size:1
;@int_isr RSRbits                   Allocated to registers ;size:1
;@int_isr PORT6bits                 Allocated to registers ;size:1
;@int_isr TC1CONbits                Allocated to registers ;size:1
;@int_isr TC1PRDbits                Allocated to registers ;size:1
;@int_isr PWM1DTbits                Allocated to registers ;size:1
;@int_isr PWM2DTbits                Allocated to registers ;size:1
;@int_isr PWM3DTbits                Allocated to registers ;size:1
;@int_isr P6IWEbits                 Allocated to registers ;size:1
;@int_isr CPUCONbits                Allocated to registers ;size:1
;@int_isr INTFbits                  Allocated to registers ;size:1
;@int_isr P6PHbits                  Allocated to registers ;size:1
;@int_isr P6PDbits                  Allocated to registers ;size:1
;@int_isr P6CONbits                 Allocated to registers ;size:1
;@int_isr E2PADRbits                Allocated to registers ;size:1
;@int_isr E2PDATbits                Allocated to registers ;size:1
;@int_isr E2PCONbits                Allocated to registers ;size:1
;@int_isr E2PREADbits               Allocated to registers ;size:1
;@int_isr TC0CONbits                Allocated to registers ;size:1
;@int_isr SYSCONbits                Allocated to registers ;size:1
;@int_isr INTEbits                  Allocated to registers ;size:1
;@int_isr bit_flag1                 Allocated to registers ;size:1
;@int_isr A_BUFF                    Allocated to registers ;size:1
;@int_isr R3_BUFF                   Allocated to registers ;size:1
;@int_isr reg_contTime              Allocated to registers ;size:1
;@int_isr reg_keyCont               Allocated to registers ;size:1
;@int_isr reg_sleep_cnt             Allocated to registers ;size:1
;@int_isr IAR                       Allocated to registers ;size:1
;@int_isr TC0C                      Allocated to registers ;size:1
;@int_isr PCL                       Allocated to registers ;size:1
;@int_isr STATUS                    Allocated to registers ;size:1
;@int_isr RSR                       Allocated to registers ;size:1
;@int_isr PORT6                     Allocated to registers ;size:1
;@int_isr TC1CON                    Allocated to registers ;size:1
;@int_isr TC1PRD                    Allocated to registers ;size:1
;@int_isr PWM1DT                    Allocated to registers ;size:1
;@int_isr PWM2DT                    Allocated to registers ;size:1
;@int_isr PWM3DT                    Allocated to registers ;size:1
;@int_isr P6IWE                     Allocated to registers ;size:1
;@int_isr CPUCON                    Allocated to registers ;size:1
;@int_isr INTF                      Allocated to registers ;size:1
;@int_isr P6PH                      Allocated to registers ;size:1
;@int_isr P6PD                      Allocated to registers ;size:1
;@int_isr P6CON                     Allocated to registers ;size:1
;@int_isr E2PADR                    Allocated to registers ;size:1
;@int_isr E2PDAT                    Allocated to registers ;size:1
;@int_isr E2PCON                    Allocated to registers ;size:1
;@int_isr E2PREAD                   Allocated to registers ;size:1
;@int_isr TC0CON                    Allocated to registers ;size:1
;@int_isr SYSCON                    Allocated to registers ;size:1
;@int_isr INTE                      Allocated to registers ;size:1
;@end Allocation info for local variables in function 'int_isr';

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; reset vector 
;--------------------------------------------------------
STARTUP	code 0x0000
	jmp	_main
;--------------------------------------------------------
; interrupt and initialization code
;--------------------------------------------------------
c_interrupt	code	0x0003
__sdcc_interrupt:
;***
;  pBlock Stats: dbName = I
;***
;2 compiler assigned registers:
;   r0x1000
;   r0x1001
;; Starting pCode block
_int_isr:	;Function start
; 0 exit points
;	.line	26; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	__asm__("org 0x08");			//жڵַ			
	org	0x08
;	.line	27; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	PUSH(_A_BUFF,_R3_BUFF);			//жջ
	mov	_A_BUFF,a
	swap	_A_BUFF
	swapa	STATUS
	mov	_R3_BUFF,a
;	.line	29; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	if(TCIF)						//жTCIFǷΪ1
	JBTS	_INTFbits,0
	JMP	_00106_DS_
;	.line	31; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	TC0C += 0x06;				//1/2 * 8 * (256-6) = 1000us	ʽ1/IRCƵ * ԤƵ * 256-ֵ
	MOV	A,@0x06
	ADD	_TC0C,A
;	.line	32; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	INTF = 0xfe;				//TC0жϱ־λ
	MOV	A,@0xfe
	MOV	_INTF,A
;	.line	33; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	io_ledOut = !io_ledOut;			//P62ڷת
	CLR	r0x1000
	JBTC	_PORT6bits,2
	INC	r0x1000
	MOV	A,r0x1000
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1000,A
	MOV	r0x1001,A
;;102	MOV	A,r0x1001
	RCA	r0x1000
	JBTS	STATUS,0
	BTC	_PORT6bits,2
	JBTC	STATUS,0
	BTS	_PORT6bits,2
_00106_DS_:
;	.line	35; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	if(EXIF)						//жEXIFǷΪ1,ⲿж
	JBTS	_INTFbits,2
	JMP	_00108_DS_
;	.line	37; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	INTF = 0xfb;				//EXIFжϱ־λ
	MOV	A,@0xfb
	MOV	_INTF,A
;	.line	38; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	PORT6_4 = !PORT6_4;				//P64ڷת
	CLR	r0x1000
	JBTC	_PORT6bits,4
	INC	r0x1000
	MOV	A,r0x1000
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1000,A
	MOV	r0x1001,A
;;101	MOV	A,r0x1001
	RCA	r0x1000
	JBTS	STATUS,0
	BTC	_PORT6bits,4
	JBTC	STATUS,0
	BTS	_PORT6bits,4
_00108_DS_:
;	.line	40; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	if(ICIF)						//жICIFǷΪ1,˿ڱ仯ж
	JBTS	_INTFbits,1
	JMP	_00110_DS_
;	.line	42; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	INTF = 0xfd;				//ICIFжϱ־λ
	MOV	A,@0xfd
	MOV	_INTF,A
;	.line	43; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	PORT6_4 = !PORT6_4;				//P64ڷת
	CLR	r0x1000
	JBTC	_PORT6bits,4
	INC	r0x1000
	MOV	A,r0x1000
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1000,A
	MOV	r0x1001,A
;;100	MOV	A,r0x1001
	RCA	r0x1000
	JBTS	STATUS,0
	BTC	_PORT6bits,4
	JBTC	STATUS,0
	BTS	_PORT6bits,4
_00110_DS_:
;	.line	45; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	if(T1IF)						//жT1IFǷΪ1,pwmж
	JBTS	_INTFbits,3
	JMP	_00112_DS_
;	.line	47; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	INTF = 0xf7;				//ISRbit3:T1IF
	MOV	A,@0xf7
	MOV	_INTF,A
;	.line	48; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	PORT6_4 = !PORT6_4;				//P64ڷת
	CLR	r0x1000
	JBTC	_PORT6bits,4
	INC	r0x1000
	MOV	A,r0x1000
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1000,A
	MOV	r0x1001,A
;;99	MOV	A,r0x1001
	RCA	r0x1000
	JBTS	STATUS,0
	BTC	_PORT6bits,4
	JBTC	STATUS,0
	BTS	_PORT6bits,4
_00112_DS_:
;	.line	50; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	INTF = 0x05;					//岻õı־λ
	MOV	A,@0x05
	MOV	_INTF,A
;	.line	51; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	POP(_A_BUFF,_R3_BUFF);			//жϳջָ
	swapa	_R3_BUFF
	mov	STATUS,a
	swapa	_A_BUFF
;	.line	52; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	}
END_OF_INTERRUPT:
	RETI	

;--------------------------------------------------------
; code
;--------------------------------------------------------
code_XC8E855E_INT	code
;***
;  pBlock Stats: dbName = M
;***
;has an exit
;functions called:
;   _file_clrRam
;   _file_init
;   _file_project_init
;   _file_clrRam
;   _file_init
;   _file_project_init
;; Starting pCode block
S_XC8E855E_INT__main	code
_main:	;Function start
; 2 exit points
;	.line	109; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	file_clrRam();					//RAM
	CALL	_file_clrRam
;	.line	110; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	file_init();					//ioĴʼ
	CALL	_file_init
;	.line	111; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	file_project_init();			//蹦
	CALL	_file_project_init
;	.line	112; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	EI();							//ж
	ei	
_00133_DS_:
;	.line	116; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	NOP();
	nop	
;	.line	117; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	NOP();
	nop	
;	.line	118; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	NOP();
	nop	
	JMP	_00133_DS_
;	.line	120; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	}
	RET	
; exit point of _main

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_INT__file_project_init	code
_file_project_init:	;Function start
; 2 exit points
;	.line	86; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	P6CON = 0x01;					//P60
	MOV	A,@0x01
	MOV	_P6CON,A
;	.line	87; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	SYSCON = 0x40;					//Bit<6>:EIS-P60 ⲿжʹλ,P60ΪжϽ
	MOV	A,@0x40
	MOV	_SYSCON,A
;	.line	88; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	NEDGEN = 1;						//½ش
	BTS	_SYSCONbits,4
;	.line	90; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	INTE = 0x05;					//TC0+P60ⲿж/* */ 			
	MOV	A,@0x05
	MOV	_INTE,A
;	.line	102; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	}
	RET	
; exit point of _file_project_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_INT__file_init	code
_file_init:	;Function start
; 2 exit points
;	.line	68; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	TC0CON = 0x82;					//TC0ʹ  8Ƶ
	MOV	A,@0x82
	MOV	_TC0CON,A
;	.line	69; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	TC0C = 6;						//1/2 * 8 * (256-6) = 1000us	ʽ1/IRCƵ * ԤƵ * 256-ֵ
	MOV	A,@0x06
	MOV	_TC0C,A
;	.line	70; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	PORT6 = 0;						//P6
	CLR	_PORT6
;	.line	71; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	P6CON = 0x00;					//P6Ϊ
	CLR	_P6CON
;	.line	72; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	P6PD = 0xff;					//˿ƼĴ  bit7-bit0ӦP67-P60
	MOV	A,@0xff
	MOV	_P6PD,A
;	.line	73; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	P6PH = 0xff;					//˿ƼĴ  bit7-bit0ӦP67-P60
	MOV	A,@0xff
	MOV	_P6PH,A
;	.line	74; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	CPUCON = 0xc0;					//bit7~6:11-ֹ,10-7pF,01-9pF,00-12pF
	MOV	A,@0xc0
	MOV	_CPUCON,A
;	.line	75; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	SYSCON = 0x00;					//WDT ʹܿƼĴ
	CLR	_SYSCON
;	.line	76; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	INTE = 0x01;					//жʹܿƼĴ 
	MOV	A,@0x01
	MOV	_INTE,A
;	.line	77; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	INTF = 0x0;						//TC0жϱ־λ 
	CLR	_INTF
;	.line	78; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	}
	RET	
; exit point of _file_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_INT__file_clrRam	code
_file_clrRam:	;Function start
; 2 exit points
;	.line	58; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	for(RSR=0x90;RSR<0xDF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	MOV	A,@0x90
	MOV	_RSR,A
_00119_DS_:
	MOV	A,@0xdf
	SUB	A,_RSR
	JBTC	STATUS,0
	JMP	_00117_DS_
;	.line	60; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	{IAR = 0;}
	CLR	_IAR
;	.line	58; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	for(RSR=0x90;RSR<0xDF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	INC	_RSR
	JMP	_00119_DS_
_00117_DS_:
;	.line	61; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	IAR = 0;
	CLR	_IAR
;	.line	62; F:\3\3DEMOд\855E_DEMO\C\XJ\4_XC8E855E_INT\XC8E855E_INT.C	}
	RET	
; exit point of _file_clrRam


;	code size estimation:
;	  118+    0 =   118 instructions (  236 byte)

	end
