;--------------------------------------------------------
; File Created by SLCC : free open source ANSI-C Compiler
; Version 3.6.0 #Jul 10 2023 (MSVC)
;--------------------------------------------------------
; SL port for the RISC core
;--------------------------------------------------------
;	.file	"F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C"
	list	p=XC8E855E
	radix dec
	include "XC8E855E.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_file_ClrRam
	extern	_file_PWMint
	extern	_file_ADCint
	extern	_file_INTint
	extern	_file_adc_start
	extern	_IARbits
	extern	_TC0Cbits
	extern	_PCLbits
	extern	_STATUSbits
	extern	_RSRbits
	extern	_PORT6bits
	extern	_TC1CONbits
	extern	_TC1PRDbits
	extern	_PWM1DTbits
	extern	_PWM2DTbits
	extern	_PWM3DTbits
	extern	_P6IWEbits
	extern	_CPUCONbits
	extern	_INTFbits
	extern	_P6PHbits
	extern	_P6PDbits
	extern	_P6CONbits
	extern	_E2PADRbits
	extern	_E2PDATbits
	extern	_E2PCONbits
	extern	_E2PREADbits
	extern	_TC0CONbits
	extern	_SYSCONbits
	extern	_INTEbits
	extern	_IAR
	extern	_TC0C
	extern	_PCL
	extern	_STATUS
	extern	_RSR
	extern	_PORT6
	extern	_TC1CON
	extern	_TC1PRD
	extern	_PWM1DT
	extern	_PWM2DT
	extern	_PWM3DT
	extern	_P6IWE
	extern	_CPUCON
	extern	_INTF
	extern	_P6PH
	extern	_P6PD
	extern	_P6CON
	extern	_E2PADR
	extern	_E2PDAT
	extern	_E2PCON
	extern	_E2PREAD
	extern	_TC0CON
	extern	_SYSCON
	extern	_INTE
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_file_init
	global	_int_isr
	global	_file_clrRam
	global	_file_tc0_wakeIDEL_set
	global	_file_tc0_exitIDEL_set
	global	_file_pwm_wakeIDEL_set
	global	_file_pwm_exitIDEL_set
	global	_file_RTC_wakeIDEL_set
	global	_file_RTC_exitIDEL_set
	global	_file_IDLEWake_slep
	global	_main
	global	_bit_flag1
	global	_A_BUFF
	global	_R3_BUFF
	global	_reg_contTime
	global	_reg_keyCont
	global	_reg_sleep_cnt

	global STK11
	global STK10
	global STK09
	global STK08
	global STK07
	global STK06
	global STK05
	global STK04
	global STK03
	global STK02
	global STK01
	global STK00

sharebank udata_ovr 0x0020
STK11	res 1
STK10	res 1
STK09	res 1
STK08	res 1
STK07	res 1
STK06	res 1
STK05	res 1
STK04	res 1
STK03	res 1
STK02	res 1
STK01	res 1
STK00	res 1

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
UD_XC8E855E_IDLE_0	udata
_bit_flag1	res	1

UD_XC8E855E_IDLE_1	udata
_reg_contTime	res	1

UD_XC8E855E_IDLE_2	udata
_reg_keyCont	res	1

UD_XC8E855E_IDLE_3	udata
_reg_sleep_cnt	res	1

;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
UD_abs_XC8E855E_IDLE_10	udata_ovr	0x0010
_A_BUFF
	res	1
UD_abs_XC8E855E_IDLE_11	udata_ovr	0x0011
_R3_BUFF
	res	1
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_XC8E855E_IDLE_0	udata
r0x1001	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

;@Allocation info for local variables in function 'int_isr'
;@int_isr file_init                 Allocated to registers ;size:2
;@int_isr file_ClrRam               Allocated to registers ;size:2
;@int_isr file_PWMint               Allocated to registers ;size:2
;@int_isr file_ADCint               Allocated to registers ;size:2
;@int_isr file_INTint               Allocated to registers ;size:2
;@int_isr file_adc_start            Allocated to registers ;size:2
;@int_isr int_isr                   Allocated to registers ;size:2
;@int_isr IARbits                   Allocated to registers ;size:1
;@int_isr TC0Cbits                  Allocated to registers ;size:1
;@int_isr PCLbits                   Allocated to registers ;size:1
;@int_isr STATUSbits                Allocated to registers ;size:1
;@int_isr RSRbits                   Allocated to registers ;size:1
;@int_isr PORT6bits                 Allocated to registers ;size:1
;@int_isr TC1CONbits                Allocated to registers ;size:1
;@int_isr TC1PRDbits                Allocated to registers ;size:1
;@int_isr PWM1DTbits                Allocated to registers ;size:1
;@int_isr PWM2DTbits                Allocated to registers ;size:1
;@int_isr PWM3DTbits                Allocated to registers ;size:1
;@int_isr P6IWEbits                 Allocated to registers ;size:1
;@int_isr CPUCONbits                Allocated to registers ;size:1
;@int_isr INTFbits                  Allocated to registers ;size:1
;@int_isr P6PHbits                  Allocated to registers ;size:1
;@int_isr P6PDbits                  Allocated to registers ;size:1
;@int_isr P6CONbits                 Allocated to registers ;size:1
;@int_isr E2PADRbits                Allocated to registers ;size:1
;@int_isr E2PDATbits                Allocated to registers ;size:1
;@int_isr E2PCONbits                Allocated to registers ;size:1
;@int_isr E2PREADbits               Allocated to registers ;size:1
;@int_isr TC0CONbits                Allocated to registers ;size:1
;@int_isr SYSCONbits                Allocated to registers ;size:1
;@int_isr INTEbits                  Allocated to registers ;size:1
;@int_isr bit_flag1                 Allocated to registers ;size:1
;@int_isr A_BUFF                    Allocated to registers ;size:1
;@int_isr R3_BUFF                   Allocated to registers ;size:1
;@int_isr reg_contTime              Allocated to registers ;size:1
;@int_isr reg_keyCont               Allocated to registers ;size:1
;@int_isr reg_sleep_cnt             Allocated to registers ;size:1
;@int_isr IAR                       Allocated to registers ;size:1
;@int_isr TC0C                      Allocated to registers ;size:1
;@int_isr PCL                       Allocated to registers ;size:1
;@int_isr STATUS                    Allocated to registers ;size:1
;@int_isr RSR                       Allocated to registers ;size:1
;@int_isr PORT6                     Allocated to registers ;size:1
;@int_isr TC1CON                    Allocated to registers ;size:1
;@int_isr TC1PRD                    Allocated to registers ;size:1
;@int_isr PWM1DT                    Allocated to registers ;size:1
;@int_isr PWM2DT                    Allocated to registers ;size:1
;@int_isr PWM3DT                    Allocated to registers ;size:1
;@int_isr P6IWE                     Allocated to registers ;size:1
;@int_isr CPUCON                    Allocated to registers ;size:1
;@int_isr INTF                      Allocated to registers ;size:1
;@int_isr P6PH                      Allocated to registers ;size:1
;@int_isr P6PD                      Allocated to registers ;size:1
;@int_isr P6CON                     Allocated to registers ;size:1
;@int_isr E2PADR                    Allocated to registers ;size:1
;@int_isr E2PDAT                    Allocated to registers ;size:1
;@int_isr E2PCON                    Allocated to registers ;size:1
;@int_isr E2PREAD                   Allocated to registers ;size:1
;@int_isr TC0CON                    Allocated to registers ;size:1
;@int_isr SYSCON                    Allocated to registers ;size:1
;@int_isr INTE                      Allocated to registers ;size:1
;@end Allocation info for local variables in function 'int_isr';

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; reset vector 
;--------------------------------------------------------
STARTUP	code 0x0000
	jmp	_main
;--------------------------------------------------------
; interrupt and initialization code
;--------------------------------------------------------
c_interrupt	code	0x0003
__sdcc_interrupt:
;***
;  pBlock Stats: dbName = I
;***
;2 compiler assigned registers:
;   r0x1001
;   r0x1002
;; Starting pCode block
_int_isr:	;Function start
; 0 exit points
;	.line	27; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	__asm__("org 0x08");			//жڵַ			
	org	0x08
;	.line	28; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	PUSH(_A_BUFF,_R3_BUFF);			//жջ
	mov	_A_BUFF,a
	swap	_A_BUFF
	swapa	STATUS
	mov	_R3_BUFF,a
;	.line	30; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	if(TCIF)						//жTCIFǷΪ1
	JBTS	_INTFbits,0
	JMP	_00106_DS_
;	.line	33; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	INTF = 0xfe;				//TC0жϱ־λ
	MOV	A,@0xfe
	MOV	_INTF,A
;	.line	34; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	PORT6_0 = !PORT6_0;			//P64ڷת
	CLR	r0x1001
	JBTC	_PORT6bits,0
	INC	r0x1001
	MOV	A,r0x1001
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1001,A
;;1	MOV	r0x1002,A
;;99	MOV	A,r0x1002
	RCA	r0x1001
	JBTS	STATUS,0
	BTC	_PORT6bits,0
	JBTC	STATUS,0
	BTS	_PORT6bits,0
_00106_DS_:
;	.line	36; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	INTF=0x01;						//岻õı־λ
	MOV	A,@0x01
	MOV	_INTF,A
;	.line	37; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	POP(_A_BUFF,_R3_BUFF);			//жϳջָ
	swapa	_R3_BUFF
	mov	STATUS,a
	swapa	_A_BUFF
;	.line	38; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
END_OF_INTERRUPT:
	RETI	

;--------------------------------------------------------
; code
;--------------------------------------------------------
code_XC8E855E_IDLE	code
;***
;  pBlock Stats: dbName = M
;***
;has an exit
;functions called:
;   _file_clrRam
;   _file_init
;   _file_IDLEWake_slep
;   _file_clrRam
;   _file_init
;   _file_IDLEWake_slep
;; Starting pCode block
S_XC8E855E_IDLE__main	code
_main:	;Function start
; 2 exit points
;	.line	176; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	file_clrRam();					//RAM
	CALL	_file_clrRam
;	.line	177; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	file_init();					//ioĴʼ
	CALL	_file_init
;	.line	179; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	EI();							//ж
	ei	
_00153_DS_:
;	.line	182; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	file_IDLEWake_slep();		//IDLEģʽ	
	CALL	_file_IDLEWake_slep
;	.line	183; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	184; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	185; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
	JMP	_00153_DS_
;	.line	187; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _main

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;functions called:
;   _file_RTC_wakeIDEL_set
;   _file_RTC_exitIDEL_set
;   _file_RTC_wakeIDEL_set
;   _file_RTC_exitIDEL_set
;; Starting pCode block
S_XC8E855E_IDLE__file_IDLEWake_slep	code
_file_IDLEWake_slep:	;Function start
; 2 exit points
;	.line	145; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	for(reg_sleep_cnt=0;reg_sleep_cnt<10;reg_sleep_cnt++)
	CLR	_reg_sleep_cnt
_00147_DS_:
;	.line	147; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	DI();
	di	
;	.line	148; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CWDT();
	cwdt	
;	.line	152; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	file_RTC_wakeIDEL_set();	//RTCIDEL 62.5*10=625msһ
	CALL	_file_RTC_wakeIDEL_set
;	.line	155; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	SLEEP();
	sleep	
;	.line	156; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	157; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	161; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	file_RTC_exitIDEL_set();	//RTCIDEL
	CALL	_file_RTC_exitIDEL_set
;	.line	145; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	for(reg_sleep_cnt=0;reg_sleep_cnt<10;reg_sleep_cnt++)
	INC	_reg_sleep_cnt
	MOV	A,@0x0a
	SUB	A,_reg_sleep_cnt
	JBTS	STATUS,0
	JMP	_00147_DS_
;	.line	164; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	reg_sleep_cnt = 0;
	CLR	_reg_sleep_cnt
;	.line	165; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	io_led2Out=1;	
	BTS	_PORT6bits,0
;	.line	166; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	167; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	168; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	io_led2Out=0; 
	BTC	_PORT6bits,0
;	.line	169; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _file_IDLEWake_slep

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_IDLE__file_RTC_exitIDEL_set	code
_file_RTC_exitIDEL_set:	;Function start
; 2 exit points
;	.line	133; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	IDLE=0;						//0:ϵͳִ SLEEP ָʱ˯ģʽ	
	BTC	_CPUCONbits,0
;	.line	135; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CPUCON = 0xC0;					//bit7~6:11-ֹ,10-7pF,01-9pF,00-12pF
	MOV	A,@0xc0
	MOV	_CPUCON,A
;	.line	136; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0WKEN = 0;					//0:TC0 ѽֹ
	BTC	_SYSCONbits,3
;	.line	137; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	STPHX=0;						//0:ʱ
	BTC	_CPUCONbits,2
;	.line	138; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CLKMD=0;						//0:ϵͳʱʹø IRC ߾ʱ 	 
	BTC	_CPUCONbits,1
;	.line	139; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _file_RTC_exitIDEL_set

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_IDLE__file_RTC_wakeIDEL_set	code
_file_RTC_wakeIDEL_set:	;Function start
; 2 exit points
;	.line	121; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0CON = 0xC0;					//TC0ԤƵ1:2,bit7:RTCSʹ0xC4;bit6=1:ѡⲿʱ 
	MOV	A,@0xc0
	MOV	_TC0CON,A
;	.line	122; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0C = 0;						//ʱжT = (1/32.768KHz)*4Clock*2*256 = 62.5ms 
	CLR	_TC0C
;	.line	123; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CPUCON = 0x00;					//bit7~6:11-ֹ,10-7pF,01-9pF,00-12pF
	CLR	_CPUCON
;	.line	124; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	125; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	IDLE=1;							//1:ϵͳִ SLEEP ָʱģʽϵͳʱ
	BTS	_CPUCONbits,0
;	.line	127; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0WKEN = 1;					//1:TC0ʹ,ɻѿģʽ,RTC ģʽ¿ɻ˯Լģʽ
	BTS	_SYSCONbits,3
;	.line	128; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CLKMD=1;						//1:ϵͳʱʹõ RC ʱ
	BTS	_CPUCONbits,1
;	.line	129; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	STPHX=1;						//1:ֹͣʱӣ IRC ;ʱӣ RTC ʱӣ 	
	BTS	_CPUCONbits,2
;	.line	130; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _file_RTC_wakeIDEL_set

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_IDLE__file_pwm_exitIDEL_set	code
_file_pwm_exitIDEL_set:	;Function start
; 2 exit points
;	.line	108; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	IDLE = 0;						//ϵͳִ SLEEP ָʱ˯ģʽ	
	BTC	_CPUCONbits,0
;	.line	109; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC1CKS = 0;						//0:ѡָʱ
	BTC	_CPUCONbits,4
;	.line	110; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	PWMWKEN = 0;					//0:PWM ѽֹ	
	BTC	_SYSCONbits,2
;	.line	111; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	STPHX = 0;						//0:ʱ
	BTC	_CPUCONbits,2
;	.line	112; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CLKMD = 0;						//0:ϵͳʱʹø IRC ߾ʱ 
	BTC	_CPUCONbits,1
;	.line	113; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _file_pwm_exitIDEL_set

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_IDLE__file_pwm_wakeIDEL_set	code
_file_pwm_wakeIDEL_set:	;Function start
; 2 exit points
;	.line	95; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC1CON = 0x88;					//pwm=255*2(Ƶ)*(1/RCʱ)=40ms  12.7K
	MOV	A,@0x88
	MOV	_TC1CON,A
;	.line	96; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC1PRD = 255;					//PWMڼĴ
	MOV	A,@0xff
	MOV	_TC1PRD,A
;	.line	97; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	98; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();		
	nop	
;	.line	100; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	IDLE = 1;						//1:ϵͳִ SLEEP ָʱģʽϵͳʱ
	BTS	_CPUCONbits,0
;	.line	101; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	PWMWKEN = 1;					//1:PWM ʹܣɻѿģʽ 
	BTS	_SYSCONbits,2
;	.line	102; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC1CKS = 1;						//1:ѡϵͳʱFosc
	BTS	_CPUCONbits,4
;	.line	103; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CLKMD = 1;						//1:ϵͳʱʹõ RC ʱ
	BTS	_CPUCONbits,1
;	.line	104; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	STPHX = 1;						//1:ֹͣʱӣ IRC ;ʱӣ RTC ʱӣ 
	BTS	_CPUCONbits,2
;	.line	105; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _file_pwm_wakeIDEL_set

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_IDLE__file_tc0_exitIDEL_set	code
_file_tc0_exitIDEL_set:	;Function start
; 2 exit points
;	.line	83; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	IDLE = 0;						//0:ϵͳִ SLEEP ָʱ˯ģʽ	
	BTC	_CPUCONbits,0
;	.line	84; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0CKS = 0;						//TC0 ʱԴѡ,0:ѡָʱ
	BTC	_CPUCONbits,5
;	.line	85; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0WKEN = 0;					//0:TC0 ѽֹ	
	BTC	_SYSCONbits,3
;	.line	86; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	STPHX = 0;						//0:ʱ
	BTC	_CPUCONbits,2
;	.line	87; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CLKMD = 0;						//0:ϵͳʱʹø IRC ߾ʱ 
	BTC	_CPUCONbits,1
;	.line	88; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _file_tc0_exitIDEL_set

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_IDLE__file_tc0_wakeIDEL_set	code
_file_tc0_wakeIDEL_set:	;Function start
; 2 exit points
;	.line	71; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0CON = 0x80;					//ԤƵָTC0 2Ƶ
	MOV	A,@0x80
	MOV	_TC0CON,A
;	.line	72; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	73; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	NOP();
	nop	
;	.line	74; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0C = 0;						//TC0ʱʱ=TC0*TC0Ƶ*(1/RCʱ)=256*2*(1/RCʱ) 
	CLR	_TC0C
;	.line	75; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	IDLE = 1;						//1:ϵͳִ SLEEP ָʱģʽϵͳʱ
	BTS	_CPUCONbits,0
;	.line	76; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0CKS = 1;						//TC0 ʱԴѡ,1:ѡϵͳʱ
	BTS	_CPUCONbits,5
;	.line	77; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0WKEN = 1;					//1:TC0ʹ,ɻѿģʽ,RTC ģʽ¿ɻ˯Լģʽ
	BTS	_SYSCONbits,3
;	.line	78; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CLKMD = 1;						//1:ϵͳʱʹõ RC ʱ
	BTS	_CPUCONbits,1
;	.line	79; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	STPHX = 1;						//1:ֹͣʱӣ IRC ;ʱӣ RTC ʱӣ 	
	BTS	_CPUCONbits,2
;	.line	80; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _file_tc0_wakeIDEL_set

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_IDLE__file_init	code
_file_init:	;Function start
; 2 exit points
;	.line	54; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0CON = 0x82;					//TCC 8Ƶ
	MOV	A,@0x82
	MOV	_TC0CON,A
;	.line	55; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	TC0C = 6;						//1/2 * 8 * (256-6) = 1000us	ʽ1/IRCƵ * ԤƵ * 256-ֵ
	MOV	A,@0x06
	MOV	_TC0C,A
;	.line	56; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	PORT6 = 0;						//P6
	CLR	_PORT6
;	.line	57; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	P6CON = 0x00;					//P6Ϊ
	CLR	_P6CON
;	.line	58; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	P6PD = 0xff;					//˿ƼĴ  bit6-bit4ӦP62-P60,bit3-bit0ӦP53-P50
	MOV	A,@0xff
	MOV	_P6PD,A
;	.line	59; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	P6PH = 0xff;					//P6˿ƼĴ  bit7-bit0ӦP67-P60
	MOV	A,@0xff
	MOV	_P6PH,A
;	.line	60; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	SYSCON = 0x00;					//WDT ʹܿƼĴ
	CLR	_SYSCON
;	.line	61; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	CPUCON = 0xC0;					//bit7~6:11-ֹ,10-7pF,01-9pF,00-12pF
	MOV	A,@0xc0
	MOV	_CPUCON,A
;	.line	62; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	INTE = 0x01;					//жʹܿƼĴ 
	MOV	A,@0x01
	MOV	_INTE,A
;	.line	63; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	INTF = 0x0;						//TC0жϱ־λ 
	CLR	_INTF
;	.line	64; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _file_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8E855E_IDLE__file_clrRam	code
_file_clrRam:	;Function start
; 2 exit points
;	.line	44; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	for(RSR=0x90;RSR<0xDF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	MOV	A,@0x90
	MOV	_RSR,A
_00113_DS_:
	MOV	A,@0xdf
	SUB	A,_RSR
	JBTC	STATUS,0
	JMP	_00111_DS_
;	.line	46; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	{IAR = 0;}
	CLR	_IAR
;	.line	44; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	for(RSR=0x90;RSR<0xDF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	INC	_RSR
	JMP	_00113_DS_
_00111_DS_:
;	.line	47; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	IAR = 0;
	CLR	_IAR
;	.line	48; F:\3\3DEMOд\855E_DEMO\C\XJ\6_XC8E855E_IDLE\XC8E855E_IDLE.C	}
	RET	
; exit point of _file_clrRam


;	code size estimation:
;	  112+    0 =   112 instructions (  224 byte)

	end
